var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var JaegerModule_1;
import { Global } from '@nestjs/common';
import { JaegerMiddleware } from './jaeger.middleware';
import { RequestSpanService } from './request-span.service';
import { RequestContext } from './request-context';
import { SpanService } from './span.service';
import { TRACER_OPTIONS } from './tracer.keys';
import { TracerService } from './tracer.service';
let JaegerModule = JaegerModule_1 = class JaegerModule {
    static forRootAsync(options) {
        const imports = [...(options.imports ?? [])];
        const providers = getProviders();
        if ('useExisting' in options) {
            providers.push({
                provide: TRACER_OPTIONS,
                useExisting: options.useExisting
            });
        }
        else {
            providers.push({
                provide: TRACER_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject
            });
        }
        return {
            global: true,
            module: JaegerModule_1,
            providers,
            imports,
            exports: [...providers, TRACER_OPTIONS]
        };
    }
    static forRoot(options) {
        const providers = getProviders();
        return {
            global: true,
            module: JaegerModule_1,
            providers: [...providers, { provide: TRACER_OPTIONS, useValue: { ...options } }],
            exports: [...providers, TRACER_OPTIONS]
        };
    }
};
JaegerModule = JaegerModule_1 = __decorate([
    Global()
], JaegerModule);
export { JaegerModule };
function getProviders() {
    return [JaegerMiddleware, SpanService, TracerService, RequestContext, RequestSpanService];
}
