var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Inject, Injectable } from '@nestjs/common';
import { LOGGER_LOG_LEVEL, LOGGER_PRETTY_PRINT, LoggerService } from '@newtral/nestjs-logger';
import { SpanService } from '../jaeger/span.service';
import { SpanLogger } from './span-logger';
let JaegerLoggerService = class JaegerLoggerService {
    constructor(level, prettyPrint = true, spanService) {
        this.level = level;
        this.prettyPrint = prettyPrint;
        this.spanService = spanService;
        this.loggerService = new LoggerService(this.level, this.prettyPrint);
    }
    /**
     * Create a new logger
     * @param moduleOrName - NodeJS module or name for the logger. When a module is given the name will be the module filename
     * @param level - Log level. By default the same level as the logger service instance but it could be overridden
     */
    getLogger(moduleOrName, level = this.level) {
        const logger = this.loggerService.getLogger(moduleOrName, level);
        // If the level is not enabled we can return a regular logger
        if (this.isLevelEnabled(level)) {
            return new SpanLogger(logger, () => this.spanService.getActiveSpan());
        }
        return logger;
    }
    isLevelEnabled(level) {
        return level !== 'silent' && levels[this.level] >= levels[level];
    }
};
JaegerLoggerService = __decorate([
    Injectable(),
    __param(0, Inject(LOGGER_LOG_LEVEL)),
    __param(1, Inject(LOGGER_PRETTY_PRINT)),
    __metadata("design:paramtypes", [String, Boolean, SpanService])
], JaegerLoggerService);
export { JaegerLoggerService };
const levels = {
    fatal: 60,
    error: 50,
    warn: 40,
    info: 30,
    debug: 20,
    trace: 10,
    silent: 0
};
