import { DynamicModule, ModuleMetadata, Provider } from '@nestjs/common';
import { TracingConfig, TracingOptions } from 'jaeger-client';
export declare class JaegerModule {
    static forRootAsync(options: TracerModuleAsyncOptions): DynamicModule;
    static forRoot(options: TracerConfiguration): DynamicModule;
}
export interface TracerConfiguration {
    config?: TracingConfig;
    options?: TracingOptions;
}
export type TracerModuleAsyncOptions = Pick<ModuleMetadata, 'imports'> & ({
    useExisting: Provider | string | symbol;
} | {
    useFactory: (...args: any[]) => Promise<TracerConfiguration> | TracerConfiguration;
    inject?: any[];
});
