"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var JaegerModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.JaegerModule = void 0;
const common_1 = require("@nestjs/common");
const jaeger_middleware_1 = require("./jaeger.middleware");
const request_span_service_1 = require("./request-span.service");
const request_context_1 = require("./request-context");
const span_service_1 = require("./span.service");
const tracer_keys_1 = require("./tracer.keys");
const tracer_service_1 = require("./tracer.service");
let JaegerModule = JaegerModule_1 = class JaegerModule {
    static forRootAsync(options) {
        const imports = [...(options.imports ?? [])];
        const providers = getProviders();
        if ('useExisting' in options) {
            providers.push({
                provide: tracer_keys_1.TRACER_OPTIONS,
                useExisting: options.useExisting
            });
        }
        else {
            providers.push({
                provide: tracer_keys_1.TRACER_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject
            });
        }
        return {
            global: true,
            module: JaegerModule_1,
            providers,
            imports,
            exports: [...providers, tracer_keys_1.TRACER_OPTIONS]
        };
    }
    static forRoot(options) {
        const providers = getProviders();
        return {
            global: true,
            module: JaegerModule_1,
            providers: [...providers, { provide: tracer_keys_1.TRACER_OPTIONS, useValue: { ...options } }],
            exports: [...providers, tracer_keys_1.TRACER_OPTIONS]
        };
    }
};
exports.JaegerModule = JaegerModule;
exports.JaegerModule = JaegerModule = JaegerModule_1 = __decorate([
    (0, common_1.Global)()
], JaegerModule);
function getProviders() {
    return [jaeger_middleware_1.JaegerMiddleware, span_service_1.SpanService, tracer_service_1.TracerService, request_context_1.RequestContext, request_span_service_1.RequestSpanService];
}
