"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InjectTracerOptions = exports.TRACER_OPTIONS = void 0;
const common_1 = require("@nestjs/common");
/**
 * Injection token for the tracer options
 *
 * @example
 *
 * ```ts
 * @Injectable()
 * class MyProvider {
 *   constructor(@Inject(TRACER_OPTIONS) private readonly config: TracerConfiguration) {}
 * }
 * ```
 */
exports.TRACER_OPTIONS = Symbol('tracer.TRACER_OPTIONS');
function InjectTracerOptions() {
    return (0, common_1.Inject)(exports.TRACER_OPTIONS);
}
exports.InjectTracerOptions = InjectTracerOptions;
