/// <reference types="node" />
import { LevelWithSilent, Logger } from '@newtral/nestjs-logger';
import { SpanService } from '../jaeger/span.service';
export declare class JaegerLoggerService {
    private readonly level;
    private readonly prettyPrint;
    private readonly spanService;
    private readonly loggerService;
    constructor(level: LevelWithSilent, prettyPrint: boolean, spanService: SpanService);
    /**
     * Create a new logger
     * @param moduleOrName - NodeJS module or name for the logger. When a module is given the name will be the module filename
     * @param level - Log level. By default the same level as the logger service instance but it could be overridden
     */
    getLogger(moduleOrName: NodeJS.Module | string, level?: import("pino").default.LevelWithSilent): Logger;
    private isLevelEnabled;
}
