"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.JaegerLoggerService = void 0;
const common_1 = require("@nestjs/common");
const nestjs_logger_1 = require("@newtral/nestjs-logger");
const span_service_1 = require("../jaeger/span.service");
const span_logger_1 = require("./span-logger");
let JaegerLoggerService = class JaegerLoggerService {
    constructor(level, prettyPrint = true, spanService) {
        this.level = level;
        this.prettyPrint = prettyPrint;
        this.spanService = spanService;
        this.loggerService = new nestjs_logger_1.LoggerService(this.level, this.prettyPrint);
    }
    /**
     * Create a new logger
     * @param moduleOrName - NodeJS module or name for the logger. When a module is given the name will be the module filename
     * @param level - Log level. By default the same level as the logger service instance but it could be overridden
     */
    getLogger(moduleOrName, level = this.level) {
        const logger = this.loggerService.getLogger(moduleOrName, level);
        // If the level is not enabled we can return a regular logger
        if (this.isLevelEnabled(level)) {
            return new span_logger_1.SpanLogger(logger, () => this.spanService.getActiveSpan());
        }
        return logger;
    }
    isLevelEnabled(level) {
        return level !== 'silent' && levels[this.level] >= levels[level];
    }
};
exports.JaegerLoggerService = JaegerLoggerService;
exports.JaegerLoggerService = JaegerLoggerService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(nestjs_logger_1.LOGGER_LOG_LEVEL)),
    __param(1, (0, common_1.Inject)(nestjs_logger_1.LOGGER_PRETTY_PRINT)),
    __metadata("design:paramtypes", [String, Boolean, span_service_1.SpanService])
], JaegerLoggerService);
const levels = {
    fatal: 60,
    error: 50,
    warn: 40,
    info: 30,
    debug: 20,
    trace: 10,
    silent: 0
};
