import { Logger } from '@newtral/nestjs-logger';
import { Span } from 'opentracing';
export declare class SpanLogger implements Logger {
    private readonly logger;
    private readonly getSpan;
    constructor(logger: Logger, getSpan: () => Span | undefined);
    fatal<T extends object>(obj: T, msg?: string, ...args: any[]): void;
    fatal(obj: unknown, msg?: string, ...args: any[]): void;
    error<T extends object>(obj: T, msg?: string, ...args: any[]): void;
    error(obj: unknown, msg?: string, ...args: any[]): void;
    warn<T extends object>(obj: T, msg?: string, ...args: any[]): void;
    warn(obj: unknown, msg?: string, ...args: any[]): void;
    info<T extends object>(obj: T, msg?: string, ...args: any[]): void;
    info(obj: unknown, msg?: string, ...args: any[]): void;
    debug<T extends object>(obj: T, msg?: string, ...args: any[]): void;
    debug(obj: unknown, msg?: string, ...args: any[]): void;
    log(level: keyof Logger, message: string | object, ...args: any[]): void;
    private logToSpan;
}
